<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table UserOneID -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title><h1>User OneID</h1></v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_user = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-account-plus</v-icon>
                      Add User
                    </v-btn>

                    <v-btn
                      @click="delete_user"
                      :disabled="disble_delete"
                      type="button"
                      color="error"
                      small
                      ><v-icon small class="pr-1">mdi-delete</v-icon>
                      Delete User
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <!-- Data-table-user-oneid -->
                  <v-data-table
                    v-model="selected"
                    :headers="headers"
                    :items="all_user_oneid"
                    :search="search"
                    :single-select="singleSelect"
                    show-select
                    item-key="oneid_user_id"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_user(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table UserOneID -->

    <!-- dialog-add-user-oneid -->
    <v-dialog v-model="dialog_add_user" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Add User OneID</v-card-title>
        <v-form ref="form_add_user">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="ชื่อ"
                    outlined
                    dense
                    v-model="form_add_user.first_name"
                    :rules="first_nameRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="นามสกุล"
                    outlined
                    dense
                    v-model="form_add_user.last_name"
                    :rules="last_nameRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    label="ตำแหน่ง"
                    outlined
                    dense
                    v-model="form_add_user.position"
                    :rules="positionRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    label="องค์กร"
                    outlined
                    dense
                    v-model="form_add_user.agency"
                    :rules="agencyRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="เบอร์"
                    outlined
                    dense
                    v-model="form_add_user.phone"
                    :rules="phoneRules"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog-edit-user -->
    <v-dialog v-model="dialog_edit_user" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Edit User OneID</v-card-title>
        <v-form ref="form_edit_user">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="ชื่อ"
                    outlined
                    dense
                    v-model="form_edit_user.first_name"
                    :rules="first_nameRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="นามสกุล"
                    outlined
                    dense
                    v-model="form_edit_user.last_name"
                    :rules="last_nameRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    label="ตำแหน่ง"
                    outlined
                    dense
                    v-model="form_edit_user.position"
                    :rules="positionRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pb-0">
                  <v-text-field
                    label="องค์กร"
                    outlined
                    dense
                    v-model="form_edit_user.agency"
                    :rules="agencyRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pb-0">
                  <v-text-field
                    label="เบอร์"
                    outlined
                    dense
                    v-model="form_edit_user.phone"
                    :rules="phoneRules"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_edit()" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit()" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
export default {
  data() {
    return {
      api: process.env.VUE_APP_API,
      selected: [],
      singleSelect: false,
      search: "",
      fab: false,
      disble_delete: true,
      dialog_loader: false,
      dialog_add_user: false,
      dialog_edit_user: false,
      form_add_user: {
        first_name: "",
        last_name: "",
        position: "",
        agency: "",
        phone: "",
      },
      form_edit_user: {
        first_name: "",
        last_name: "",
        position: "",
        agency: "",
        phone: "",
      },
      all_user_oneid: [],
      headers: [
        {
          text: "oneid",
          align: "start",
          value: "oneid_account",
          sortable: false,
        },
        {
          text: "First Name",
          align: "start",
          value: "first_name",
          sortable: false,
        },
        {
          text: "Last Name",
          align: "start",
          value: "last_name",
          sortable: false,
        },
        {
          text: "Position",
          align: "start",
          value: "position",
          sortable: false,
        },
        {
          text: "agency",
          align: "start",
          value: "agency",
          sortable: false,
        },
        {
          text: "Phone",
          align: "start",
          value: "phone",
          sortable: false,
        },

        { text: "Action", value: "actions", sortable: false },
      ],
      // rules
      first_nameRules: [(v) => !!v || "กรุณากรอกชื่อ"],
      last_nameRules: [(v) => !!v || "กรุณากรอกนามสกุล"],
      positionRules: [(v) => !!v || "กรุณากรอกตำแหน่ง"],
      agencyRules: [(v) => !!v || "กรุณากรอกสถานที่ทำงาน"],
      phoneRules: [(v) => !!v || "กรุณากรอกเบอร์"],
      session_id: this.$cookies.get("info_login").session_id,
    };
  },

  watch: {
    selected(val) {
      console.log(val);
      if (val.length == 0) {
        this.disble_delete = true;
      } else {
        this.disble_delete = false;
      }
    },
  },

  mounted() {
    console.log("api -->", this.api);
    this.get_user_oneid();
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_user_oneid() {
      this.dialog_loader = true;
      let userlogId = this.$cookies.get("info_login").user_id;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/oneid_admin/getuser_oneid", {
          params: {
            token: this.$cookies.get("info_login").token,
            userlog_id: userlogId,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          this.dialog_loader = false;
          console.log("response", response.data.data);
          this.all_user_oneid = response.data.data;
        })
        .catch((error) => {
          console.log(error);
        });
    },

    save_add() {
      if (!this.$refs.form_add_user.validate()) return;
      console.log("save");
    },

    cancel_add() {
      console.log("cancle_add");
      this.dialog_add_user = false;
      this.$refs.form_add_user.reset();
    },

    delete_user() {
      const one_id_array = [];
      for (let index = 0; index < this.selected.length; index++) {
        one_id_array.push(this.selected[index].oneid_user_id);
      }
      console.log("one_id_array", one_id_array)
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete user!",
        icon: "warning",
        showCancelButton: true,
        allowOutsideClick: false,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(
              process.env.VUE_APP_API +
                "/api/v3/oneid_admin?oneidadmin_id=" +
                one_id_array +
                "&userlog_id=" +
                this.$cookies.get("info_login").user_id,
              {
                headers: {
                  Authorization: this.session_id,
                },
              }
            )
            .then((response) => {
              console.log(response.data);
              console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: "package is using.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user_admin();
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete Admin success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_user_admin();
                });
              }
            })
            .catch((error) => {
              this.dialog_loader = false;
              console.log("error", error);
              this.$swal({
                icon: "error",
                title: "Error!",
                text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                window.location.href = this.api;
              });
            });
        }
      });
    },

    edit_user(item) {
      console.log(item);
      this.dialog_edit_user = true;
      this.form_edit_user = item;
      console.log("form-edit", this.form_edit_user.position);
    },

    save_edit() {
      console.log(this.form_edit_user);
      if (!this.$refs.form_edit_user.validate()) return;
      this.dialog_edit_user = false;
    },

    cancel_edit() {
      this.dialog_edit_user = false;
    },
  },
};
</script>

<style></style>
